'Placed in the Public Domain 5/24/97  John E. Carter
'johnecarter@mindspring.com
'
'requires PowerBasic 3 to compile
'
'08-05-95 - jec - added incr to operation loop to insure math is done
'01-14-95 - jec - added -s option to skip CPU speed check
'12-10-94 - jec - added alternate method of getting disk label if BPB call
'                 returns blanks
$LIB COM OFF
$LIB GRAPH OFF
$FLOAT EMULATE
$ERROR ALL OFF
$OPTION CNTLBREAK OFF
$include "regnames.inc"
defint a-z
mycpu = pbvCpu
mynpx = pbvNpx
color 7,0
cls
dim vmode$(15)
vmode$(0) = "text"
vmode$(1) = "CGA 320x200"
vmode$(2) = "CGA 640x200 or Herc 720x348"
vmode$(3) = "Herc 720x348"
vmode$(4) = "video mode 4"
vmode$(5) = "video mode 5"
vmode$(6) = "video mode 6"
vmode$(7) = "EGA color 320x200"
vmode$(8) = "EGA color 640x200"
vmode$(9) = "EGA color 640x350"
vmode$(10) = "EGA mono 640x350"
vmode$(11) = "VGA mono 640x480 or MCGA"
vmode$(12) = "VGA color 640x480"
vmode$(13) = "video mode 13"
vmode$(14) = "video mode 14"
vmode$(15) = "video mode 15"
cdrom$ = ""
drvtype% = 0
dfat$ = ""
dser$ = ""
dvol$ = ""
dospeed = 1
cmd$ = ucase$(command$)
if len(cmd$) then
  dashloc = instr(command$, any "-/")
  if dashloc > 0 then
    arg$ = mid$(cmd$,dashloc +1,1)
    if arg$ = "S" then
      dospeed = 0
    else
      call usage
      end
    end if
  end if
end if
'screen 9, 11, 12 also work
print
x$ = "PC Status Report  v950805  Copyright 1993-1995  John E. Carter"
x$ = FNcenter$(x$,79)
print x$
print
x$="johnecarter@mindspring.com"
x$=FNcenter$(x$,79)
print x$
print
'x$ = FNcenter$("Processor",79)
print " Processor:";  'x$
if mycpu = 1 then print " 8088/8086/80186";
if mycpu = 2 then print " 80286";
if mycpu = 3 then print " 80386+";
print " CPU, ";
if mynpx = 0 then print "no";
if mynpx = 1 then print "8087";
if mynpx = 2 then print "80287";
if mynpx = 3 then print "80387+";
print " numeric coprocessor installed"
if dospeed = 1 then
  print " Checking CPU speed:";
  if mynpx = 0 then
    rpt! = 100000
  else
    rpt! = 200000 * mycpu
  end if
  'st& = timer
  mtimer
  for k! = 1 to rpt!
    incr qt&
  next k!
  mti! = mtimer
  'en& = timer
  'secs& = en& - st&
  secs& = mti! / 1000000
  flops& = k!/secs&
  'mtx! = mti! / 1000000
  'print using "###,###&";k!/mtx!;" flops"
  print using "###,###&";flops&;" floating point operations per second"

  locate csrlin,22
  '33334 for dx-25 no co-processor
  print using "&###.#&";"(";(flops&/85714)*100;"% of 80386DX/25, with 80387 co-processor)"
'  ? " flops=";flops&,"secs=";secs&
end if
call interrupt &H12
q$ = ltrim$(str$(reg(%ax)))
print " ";q$;"K base memory, ";

reg %ax, &H8800   '256 * 136
call interrupt &H15
'mext! = reg(%ax)
'? mext!
'? bin$(reg(%flags))
'? "in ext mem check: reg(%ax)=";reg(%ax)
if (reg(%flags) and 1) = 1 then
  print " Error ";reg(%ax)\256;" in checking for extended memory"
else
  if reg(%ax) > 0 then
    print reg(%ax);"K extended memory, ";
  else
    print "no extended memory available, ";
  end if
end if

reg %ax,256 * 53 + &H67
call interrupt &H21
def seg = reg(%es)
for k=10 to 20
  kt$ = kt$ + chr$(peek(k))
'  print chr$(peek(k));
next k
'print
'? "kt$=";kt$
'if (instr(kt$,"EM") > 0) and (instr(kt$,"XXX") > 0) then
if instr(kt$,"EMMXXXX") > 0 then
  print "EMS handler installed"
else
  print "EMS handler not installed"
end if
print
'x$ = FNcenter$("Operating System",79)
print " Operating System: ";   'x$
'print "pbvHost=";bin$(pbvHost)
reg %AX, 48 * 256
call interrupt &H21
dosver = reg(%AX) and 255
dosdot = reg(%AX) \ 256
q$ =ltrim$(str$(reg(%AX) \ 256))
print using "&#&&";" DOS ";dosver;".";q$;
if pbvHost < 128 then
  print
else
  print ", running under ";
  if (pbvHost and 128) > 0 then print "DesqView"
  if (pbvHost and 256) > 0 then print "Windows 3.1+"
end if
print
print " Current Drive:";    'x$
reg %AX, (256 * 25)
'reg %BX, 1
call interrupt &H21
curdrv = reg(%AX) and 255 ' 0 = A, 1 = B, 2 = C, etc.
curdr$ = chr$(curdrv + 65) + ":"
if dosver > 3 then
  call diskinfo
end if
print " ";curdr$;            'chr$(curdrv + 65);":";
print dvol$,
if len(dser$) then
  print "Serial #: ";dser$
else
  print
end if
print " Type:";
reg %AX, (256 * 68) + 8
reg %BX,  curdrv + 1      '0 = default, 1 = A, 2 = B, 3 = C, etc.
call interrupt &H21
drvtype% = reg(%AX)
call iscdrom
if cdrom$ = chr$(curdrv + 65) then
  print " CD-ROM,";
else
  if drvtype% = 0 then print " removable,";
  if drvtype% = 1 then print " fixed,";
end if
if drvtype% = 15 then
  print " invalid drive"
else
  reg(%AX), &H3600                       'function number
  reg(%BX), 0
  reg(%CX), 0
  reg(%DX), curdrv + 1                   'drive numbers start with 0 in this function
  call interrupt &H21
  if reg(%AX) = -1 then
    print "Error accessing drive ";chr$(65 + drvno)
    beep
    end
  end if
  'AX = sectors/cluster (-1 if error), BX = available clusters,
  'CX = bytes/sector, DX = clusters/drive
  numclus& = reg(%dx)                             'need for big drives
  if numclus& < 0 then incr numclus&, 65536
  totalbytes& = reg(%CX) * reg(%AX) * numclus&    'reg(%DX)
  freeclus& = reg(%bx)
  if freeclus& < 0 then incr freeclus&, 65536
  freebytes& = reg(%CX) * reg(%AX) * freeclus&    'reg(%BX)
  print using "&###,###,###&###,###,###&";" ";freebytes&;" bytes free of ";totalbytes&;" bytes total"
  if len(ltrim$(dfat$)) then print " File Allocation Table: ";dfat$
end if
print
'x$ = FNcenter$("Screen",79)
print " Screen:"    'x$
print " Video card is ";
if (pbvScrnCard and 1) > 0 then print "mono, ";
if (pbvScrnCard and 2) > 0 then print "cga, ";
if (pbvScrnCard and 4) > 0 then print "ega mono, ";
if (pbvScrnCard and 8) > 0 then print "ega color, ";
if (pbvScrnCard and 16) > 0 then print "vga, ";
if (pbvScrnCard and 32) > 0 then print "hercules";
print " compatible"
'print " Current mode: ";
'print vmode$(pbvScrnMode),
'this gets the BW40, CO40, BW80, CO80 modes
'reg %ax, 256 * 15
'call interrupt &H10
'print reg(%ax) and 255;
'print "Columns: ";pbvScrnCols,"Rows: ";pbvScrnRows
'print " Active page: ";pbScrnApage,"Visible page: ";pbvScrnVpage,
'x$ = "Viewport: " + str$(pbvVTxtX1) + "," + ltrim$(str$(pbvVTxtY1)) + " to "
'x$ = x$ + str$(pbvVTxtX2) + "," + ltrim$(str$(pbvVTxtY2))
'replace "  " with " " in x$
'print x$
'print " Cursor: First line: ";pbvCursor1,"Last line: ";pbvCursor2,"Visible: ";
'if pbvCursorVis = True then
'  print "Yes"
'else
'  print "No"
'end if
print
'print " Program Status:"   'x$
'if (pbvHost and 32) > 0 then
'  print " Executing in IDE",
'end if
'pseg$ = hex$(pbvDefSeg)
'while len(pseg$) < 4
'  pseg$ = "0" + pseg$
'wend
'print " Default segment: ";pseg$
end

DEF FNcenter$(x$,p)
  'x$ is text to center, p is display width
  xlen = len(x$)
  if xlen >= p then
    FNcenter$ = x$
  end if
  padlen = (p - xlen)/2
  x$ = space$(padlen) + x$ + space$(padlen)
  x$ = left$(x$,p)     'allow for odd # of characters in string
  FNcenter$ = x$
END DEF

SUB diskinfo
  'valid if dos version 4 or greater
  SHARED dser$, dvol$, dfat$, curdr$
  map bpb$$ * 25, 2 as info$$, 4 as serialno$$, 11 as vol$$, 8 as fat$$
  reg %AX, &H6900
  reg %BX, 0
  reg %DS, strseg(bpb$$)
  reg %DX, strptr(bpb$$)
  call interrupt &H21
  dvol$ = ltrim$(rtrim$(vol$$))
  if len(dvol$) > 0 then
    nloc = instr(dvol$,"NO NAME")
    if nloc > 0 then
      k$ = dir$("\",8)        'dir$(curdr$,8)
      if len(k$) > 0 then
        k$ = remove$(k$,".")
        dvol$ = "   Label: " + k$   'dir$("\*.*",8)
      else
        dvol$ = ""
      end if
    else
      dvol$ =  "  Label: " + dvol$
    end if
  else
    k$ = dir$("\*.*",8)
    if len(ltrim$(k$)) > 0 then
      dvol$ = "  Label: "+ remove$(dir$("\*.*",8),".")
    end if
  end if
  dfat$ = fat$$
  lo$ = left$(serialno$$,2)
  hi$ = right$(serialno$$,2)
  hi$ = hex$(cvi(hi$))
  lo$ = hex$(cvi(lo$))
  while len(hi$) < 4
    hi$ = "0" + hi$
  wend
  while len(lo$) < 4
    lo$ = "0" + lo$
  wend
  dser$ = hi$ + "-" + lo$
END SUB

SUB iscdrom
shared cdrom$
reg %ax, &H1500
call interrupt &H2f        'call to MSCDEX to check for CD-ROM drives
al = reg(%ax) and 255      'if al = 255, MSCDEX is loaded
bl = reg(%bx) and 255      'bl is number of CD-ROM drives on machine
cl = reg(%cx) and 255      'cl is number of first CD-ROM drive (zero based)
if al = 255 and bl > 0 then
  cdrom$ = chr$(cl + 65)
'  print "CD-ROM(s): "; bl;"drive";
'  if bl > 1 then print "s beginning at";
'  print " ";chr$(cl + 65);":"
else
  cdrom$ = ""
'  print "MSCDEX not loaded.  No CD-ROM drives found."
end if
END SUB

SUB usage
print
print "usage: getsetup [-s]"
print "                 -s turns off CPU speed test"
END SUB

